=== debian/changelog ===
qpid-proton (0.37.0-7) unstable; urgency=medium

  [ Adrian Bunk ]
  * Backport upstream fixes for FTBFS with CMake 4. (Closes: #1113445)

 -- Thomas Goirand <zigo@debian.org>  Mon, 27 Oct 2025 09:27:01 +0100

qpid-proton (0.37.0-6) unstable; urgency=medium

  * Rebuild to remove python 3.12 support.

 -- Thomas Goirand <zigo@debian.org>  Wed, 26 Feb 2025 14:19:48 +0100

qpid-proton (0.37.0-5) unstable; urgency=medium

  [ Nicholas Omann ]
  * Fix pkg-config and add cmake (Closes: #1014064).

  [ Thomas Goirand ]
  * Switch from pkg-config to pkgconf build-depends.

 -- Thomas Goirand <zigo@debian.org>  Tue, 07 Jan 2025 09:19:49 +0100

qpid-proton (0.37.0-4) unstable; urgency=medium

  * Removed -O--buildsystem=python_distutils from d/rules.

 -- Thomas Goirand <zigo@debian.org>  Fri, 20 Dec 2024 11:31:43 +0100

qpid-proton (0.37.0-3) unstable; urgency=medium

  [ Sourav Bhattachtarya ]
  * Replace deprecating module cgi (Closes #1084552).

 -- Thomas Goirand <zigo@debian.org>  Mon, 04 Nov 2024 12:02:09 +0100

qpid-proton (0.37.0-2) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * Support multiple Python versions (Closes: #1024300).

 -- Thomas Goirand <zigo@debian.org>  Mon, 28 Nov 2022 11:36:59 +0100

qpid-proton (0.37.0-1) unstable; urgency=medium

  * New upstream release.
  * Adopt the package in the OpenStack team, as there's no other maintainers
    than me anymore.
  * Restart git history using upstream Git repo as base.
  * Use openstack-pkg-tools.
  * Removed all old patches.
  * Removed all traces of proton-c: files have moved upstream.
  * Fix python3-qpid-proton.install.
  * rm debian/README.source.
  * Fix 3x *doc.install files.
  * rm d/libqpid-proton11.docs.
  * Add continue-building-with-deprecated-declarations.patch. This fixes FTBFS
    with OpenSSL 3.0 (Closes: #1006562).
  * Added Restrictions: superficial to tests (Closes: #974503).
  * Removed python2 autopkgtest.
  * autopkgtest: only test with default python3, not with all available
    python3.

 -- Thomas Goirand <zigo@debian.org>  Thu, 17 Feb 2022 10:04:14 +0100
