=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

# DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk

UPSTREAM_GIT := https://github.com/apache/qpid-proton
include /usr/share/openstack-pkg-tools/pkgos.make

# This has to be exported to make some magic below work.
export DH_OPTIONS
export DH_ALWAYS_EXCLUDE=LICENSE
export PYBUILD_SYSTEM=cmake
export PYBUILD_CONFIGURE_ARGS=-DPROTON_DISABLE_RPATH=true -DNOBUILD_RUBY=on \
	-DSYSINSTALL_BINDINGS=on -DCHECK_SYSINSTALL_PYTHON=false \
	-DPYTHON_SITEARCH_PACKAGES=/usr/lib/python{version}/dist-packages \
	-DLIB_INSTALL_DIR=/usr/lib/${DEB_HOST_MULTIARCH}
export PYBUILD_BUILD_ARGS=all docs

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_test:
	# TODO enable them when they work again

override_dh_sphinxdoc:
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	PYTHONPATH=. python3 -m sphinx -b html python/docs $(CURDIR)/debian/python-qpid-proton-doc/usr/share/doc/python-qpid-proton-doc/html
	dh_sphinxdoc
endif
